stages:
  - test
  - release

test:
  image: "registry.gitlab.com/toegang-voor-iedereen/docker-images/php/php-ci-cd:${PHP_VERSION}"
  tags:
    - "${ARCH}"
  script:
    - composer install --no-interaction --no-progress --prefer-dist
    - ./vendor/bin/phpcs src/ tests/
    - ./vendor/bin/phpstan
    - ./vendor/bin/psalm
    # - ./vendor/bin/phpmd src ansi rulesets.xml
    - ./vendor/bin/phpunit
    - cat coverage.txt
    # Check coverages:
    - 'grep -A 3 "Summary:" coverage.txt | grep "Classes: 100.00%" -q'
    - 'grep -A 3 "Summary:" coverage.txt | grep "Methods: 100.00%" -q'
    - 'grep -A 3 "Summary:" coverage.txt | grep "Lines:   100.00%" -q'
  parallel:
    matrix:
      - PHP_VERSION: ["8.2", "8.3"]
        ARCH: ["amd64", "arm64"]

release:
  image: registry.gitlab.com/toegang-voor-iedereen/docker-images/php/php-ci-cd:8.3
  before_script:
    - composer config --global gitlab-token.gitlab.com gitlab-ci-token "$CI_JOB_TOKEN"
  script:
    - composer install --no-interaction --no-progress --prefer-dist --no-dev
    - echo "Checking if the version in composr.json is equal to the Git tag"
    - test "$(jq -r '.version' < composer.json)" = "$CI_COMMIT_TAG"
    - |
      curl "${CI_API_V4_URL}/projects/$CI_PROJECT_ID/packages/composer" \
        --header "Job-Token: $CI_JOB_TOKEN" \
        --data "tag=$CI_COMMIT_TAG"
  only:
    - tags
